// OptionsTree.cpp : implementation file
//

#include "stdafx.h"
#include "Test.h"
#include "OptionsTree.h"
#include "ItemData.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// COptionsTree

COptionsTree::COptionsTree()
{
}

COptionsTree::~COptionsTree()
{
}


BEGIN_MESSAGE_MAP(COptionsTree, CTreeCtrl)
	//{{AFX_MSG_MAP(COptionsTree)
	ON_NOTIFY_REFLECT(TVN_SELCHANGED, OnSelchanged)
	ON_WM_DESTROY()
	ON_NOTIFY_REFLECT(TVN_DELETEITEM, OnDeleteItem)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// COptionsTree message handlers

DWORD COptionsTree::GetItemData(HTREEITEM hItem) const
{
	CItemData * pItemData = (CItemData *)CTreeCtrl::GetItemData(hItem);
	if (pItemData == NULL)
		return NULL;
	else
		return pItemData->m_lParam; 
}

BOOL COptionsTree::SetItemData(HTREEITEM hItem, DWORD dwData)
{
	CItemData * pItemData = (CItemData *)CTreeCtrl::GetItemData(hItem);
	if (pItemData == NULL)
	{
		CItemData * pNewItemData = new CItemData;
		pNewItemData->m_lParam = dwData;
		return CTreeCtrl::SetItemData(hItem,(DWORD)pNewItemData);
	}
	else
	{
		pItemData->m_lParam = dwData;
		return TRUE;
	}
}

void COptionsTree::OnSelchanged(NMHDR* pNMHDR, LRESULT* pResult) 
{
	
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	HTREEITEM hNewItem = pNMTreeView->itemNew.hItem;
	HTREEITEM hOldItem = pNMTreeView->itemOld.hItem;
	CItemData * pNewItemData = (CItemData *)CTreeCtrl::GetItemData(hNewItem);
	CItemData * pOldItemData = NULL; 
	if (hOldItem)
		pOldItemData = (CItemData *)CTreeCtrl::GetItemData(hOldItem);
	if (pNewItemData != NULL)
		pNewItemData->m_pSheet->ShowWindows(SW_SHOW);
	if (pOldItemData != NULL)
		pOldItemData->m_pSheet->ShowWindows(SW_HIDE);
	*pResult = 0;
}

BOOL COptionsTree::AddControl(HTREEITEM hItem, CWnd *pWnd)
{
	CItemData * pItemData = (CItemData *)CTreeCtrl::GetItemData(hItem);  
	ASSERT_KINDOF(CWnd, pWnd);
	if (pItemData == NULL)
	{
		pItemData = new CItemData;
		CTreeCtrl::SetItemData(hItem,(DWORD)pItemData);
	}
	pItemData->m_pSheet->AttachControl(pWnd); 
	return TRUE;
}	 

void COptionsTree::OnDestroy() 
{
		// TODO: Add your message handler code here
	this->DeleteAllItems();
	CTreeCtrl::OnDestroy();
}

void COptionsTree::OnDeleteItem(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	CItemData * pItemData = (CItemData*)pNMTreeView->itemOld.lParam;
	if (pItemData != NULL)
	{
		delete pItemData;
	}
	*pResult = 0;
}
